admin/config/routes.rb
Spree::Core::Engine.add_routes do
  namespace :admin, path: Spree.admin_path do
    # product catalog
    resources :properties, except: :show
    resources :option_types, except: :show do
      resources :option_values, only: [:update]
    end
    resources :products do
      collection do
        get :select_options, defaults: { format: :json }
        post :search
        get :bulk_modal
        put :bulk_status_update
        put :bulk_add_to_taxons
        put :bulk_remove_from_taxons
        put :bulk_add_tags
        put :bulk_remove_tags
      end
      member do
        post :clone
      end
      resources :variants, only: [:edit, :update, :destroy]
      resources :digital_assets, except: [:show]
    end
    # variant search
    post 'variants/search'
    get 'variants/search', defaults: { format: :json }
    # stock
    resources :stock_items, only: [:index, :update, :destroy]
    resources :stock_transfers, except: [:edit, :update]
    # taxonomies and taxons
    resources :taxonomies do
      resources :taxons do
        member do
          put :reposition
        end
      end
    end
    resources :taxons, except: [:show] do |_taxon|
      resources :classifications, only: %i[index new create update destroy]
    end
    get '/taxons/select_options' => 'taxons#select_options', as: :taxons_select_options, defaults: { format: :json }

    # media library
    resources :assets, only: [:create, :edit, :update, :destroy] do
      collection do
        delete :bulk_destroy
      end
    end

    # orders
    resources :checkouts, only: %i[index]
    resources :orders, only: [:index, :edit, :create] do
      member do
        post :resend
        put :cancel
      end
      resource :shipping_address, except: [:index, :show], controller: 'orders/shipping_address'
      resource :billing_address, except: [:index, :show], controller: 'orders/billing_address'
      resource :contact_information, only: [:edit, :update], controller: 'orders/contact_information'
      resource :user, except: [:edit, :show, :index], controller: 'orders/user'
      resources :shipments, only: [:edit, :update, :create], controller: 'shipments' do
        member do
          post :ship
          get :split
          post :transfer
        end
      end
      resources :line_items, except: :show
      resources :customer_returns, except: [:index, :destroy], controller: 'orders/customer_returns'
      resources :return_authorizations, except: [:index, :destroy], controller: 'orders/return_authorizations'
      resources :payments, except: [:index, :show] do
        member do
          put :capture
          put :void
        end
        resources :refunds, only: [:new, :create, :edit, :update]
      end
      resources :payment_links, only: [:create], controller: 'orders/payment_links'
      resources :reimbursements, except: [:destroy, :index] do
        member do
          post :perform
        end
      end
    end

    # customers
    resources :users do
      resources :store_credits
      resources :orders, only: [:index]
      resources :checkouts, only: [:index]

      collection do
        get :bulk_modal
        post :bulk_add_tags
        post :bulk_remove_tags
      end
    end

    resources :addresses, except: [:index, :show]

    # promotions
    resources :promotions do
      member do
        post :clone
      end
      resources :promotion_actions, as: :actions, except: [:index, :show]
      resources :promotion_rules, as: :rules, except: [:index, :show]
      resources :coupon_codes, only: :index
    end
    get 'promotion_rules/option_values_search', defaults: { format: :json }

    # returns
    resources :return_authorizations, only: [:index, :destroy] do
      member do
        patch :cancel
      end
    end
    resources :customer_returns, only: :index
    resources :return_items, only: [:update]

    # translations
    resources :translations, only: [:edit, :update], path: '/translations/:resource_type'

    # audit log
    resources :exports, only: [:index, :new, :create, :show]

    # reporting
    resources :reports, only: [:index, :new, :create, :show]

    # profile settings
    resource :profile, controller: 'profile', only: %i[edit update]

    # store settings
    resource :store, only: [:edit, :update], controller: 'stores' do
      # needed for the getting started set customer support email step
      member do
        get :edit_emails
      end
    end
    # setting up a new store
    resources :stores, only: [:new, :create]
    resources :payment_methods, except: :show
    resources :shipping_methods, except: :show
    resources :shipping_categories, except: :show
    resources :store_credit_categories
    resources :tax_rates, except: :show
    resources :tax_categories, except: :show
    resources :reimbursement_types
    resources :refund_reasons, except: :show
    resources :return_authorization_reasons, except: :show
    resources :zones
    resources :stock_locations, except: :show do
      member do
        put :mark_as_default
      end
    end
    resources :custom_domains, except: :show

    # storefront / page builder
    resource :storefront, only: [:edit, :update], controller: :storefront
    resources :themes, except: [:new, :show] do
      member do
        put :update_with_page
        put :publish
        post :clone
      end
      resources :sections, controller: 'page_sections', only: %i[new create] do
        member do
          patch :move_higher
          patch :move_lower
        end
      end
    end
    resources :pages, except: [:show] do
      resources :sections, controller: 'page_sections', only: %i[new create] do
        member do
          patch :move_higher
          patch :move_lower
        end
      end
    end
    resources :page_sections, only: %i[edit update destroy] do
      member do
        patch :restore_design_settings_to_defaults
      end

      resources :blocks, controller: 'page_blocks' do
        member do
          patch :move_higher
          patch :move_lower
        end

        resources :links, controller: 'page_links', only: [:create]
      end
      resources :links, controller: 'page_links', only: [:create]
    end
    resources :page_links, only: [:edit, :update, :destroy]

    resources :posts do
      collection do
        get :select_options, defaults: { format: :json }
      end
    end
    resources :post_categories

    # account management
    resources :roles, except: :show

    # Action Text
    namespace :action_text do
      resources :video_embeds, only: [:create, :destroy]
    end

    # developer tools
    resources :oauth_applications
    resources :webhooks_subscribers

    # errors
    get '/forbidden', to: 'errors#forbidden', as: :forbidden

    # dashboard
    resource :dashboard, controller: 'dashboard'
    get '/dashboard/analytics', to: 'dashboard#analytics', as: :dashboard_analytics
    get '/getting-started', to: 'dashboard#getting_started', as: :getting_started

    root to: 'dashboard#show'
  end

  get Spree.admin_path, to: 'admin/dashboard#show', as: :admin
end

admin/app/controllers/spree/admin/taxons_controller.rb
module Spree
  module Admin
    class TaxonsController < ResourceController
      belongs_to 'spree/taxonomy'

      include Spree::Admin::TaxonsHelper
      include Spree::Admin::TagsHelper

      before_action :set_parent_permalink, only: :new
      before_action :set_permalink_part, only: [:edit, :update]
      before_action :set_permalink_params, only: [:update]

      update.before :set_parent
      update.before :set_position

      before_action :load_form_data, only: [:new, :create, :edit, :update]

      def show
        redirect_to location_after_save
      end

      def select_options
        render json: taxons_options_json_array(with_automatic: params[:with_automatic].to_b)
      end

      def reposition
        authorize! :update, @taxon

        new_parent = @taxonomy.taxons.find(params.dig(:taxon, :new_parent_id))
        new_index = params.dig(:taxon, :new_position_idx).to_i

        if @taxon.move_to_child_with_index(new_parent, new_index)
          head :ok
        else
          head :unprocessable_entity
        end
      end

      private

      def parent_data
        super unless action == :select_options
      end

      def location_after_save
        spree.edit_admin_taxonomy_taxon_path(@taxon.taxonomy_id, @taxon.id)
      end

      def destroy_turbo_stream_enabled?
        true && !params[:force_redirect].to_b
      end

      def set_parent_permalink
        @parent_permalink = @taxon.parent.present? ? @taxon.parent.permalink : @taxon.taxonomy.root.permalink
      end

      def set_permalink_part
        @permalink_part = @taxon.permalink.split('/').last
        @parent_permalink = @taxon.permalink.split('/')[0...-1].join('/')
      end

      def set_position
        new_position = params[:taxon][:position]
        @taxon.child_index = new_position.to_i if new_position
      end

      def set_parent
        return unless params.dig(:taxon, :parent_id).present?

        @taxon.parent = @taxonomy.taxons.find_by(id: params.dig(:taxon, :parent_id))
      end

      def set_permalink_params
        params[:taxon][:permalink] = "#{@parent_permalink}/" + params[:permalink_part] if params.key? 'permalink_part'
      end

      def collection_url
        spree.admin_taxonomy_path(@taxonomy)
      end

      # this is needed to set the parent_id for the newly initialized taxons
      def build_resource
        parent.send(controller_name).build(parent_id: params.dig(:taxon, :parent_id))
      end

      def load_form_data
        @taxon_rules = Rails.application.config.spree.taxon_rules
        @rule_types = @taxon_rules.map do |taxon_rule|
          [Spree.t("admin.taxon_rules.#{taxon_rule.to_s.demodulize.underscore}"), taxon_rule.to_s]
        end

        @rule_match_policies = Spree::TaxonRule::MATCH_POLICIES.map do |policy|
          [Spree.t("admin.taxon_rules.match_policies.#{policy}"), policy]
        end
      end
    end
  end
end

admin/app/helpers/spree/admin/taxons_helper.rb
module Spree
  module Admin
    module TaxonsHelper
      def taxons_scope(with_automatic: false)
        @memoized_taxons_scope ||= {}
        @memoized_taxons_scope[with_automatic] ||= begin
          scope = current_store.taxons.where.not(parent_id: nil)
          scope = scope.where(automatic: false) unless with_automatic
          scope
        end
      end

      def taxons_options_json_array(with_automatic: false)
        taxons_scope(with_automatic: with_automatic).pluck(:id, :pretty_name).map { |id, pretty_name| { id: id, name: pretty_name } }.as_json
      end

      def taxon_sort_options_for_select
        @taxon_sort_options_for_select ||= Spree::Taxon::SORT_ORDERS.map do |sort_order|
          [
            Spree.t("products_sort_options.#{sort_order.underscore}"),
            sort_order
          ]
        end
      end
    end
  end
end

admin/app/views/spree/admin/taxons/_form.html.erb
<div class="row" data-controller="slug-form seo-form">
  <div class="col-lg-8">
    <div class="card mb-4">
      <div class="card-body pb-0 pt-3">
        <div class="form-group">
          <%= f.label :name, raw(Spree.t(:name) + required_span_tag) %>
          <%= f.text_field :name,
                class: 'form-control',
                required: true,
                autofocus: @taxon.new_record?,
                data: {
                  seo_form_target: 'sourceTitleInput',
                  slug_form_target: 'name',
                  action: 'slug-form#updateUrlFromName'
                } %>
          <%= f.error_message_on :name %>
        </div>
        <div class="form-group">
          <%= f.label :description, Spree.t(:description) %>
          <div class="trix-container">
            <%= f.rich_text_area :description, data: { seo_form_target: 'sourceDescriptionInput' } %>
          </div>
        </div>
      </div>
    </div>

    <% if @taxon.new_record? %>
      <div class="card mb-4" data-controller="reveal" data-reveal-hidden-class="d-none">
        <div class="card-header">
          <h5 class="card-title"><%= Spree.t('admin.taxon_type') %></h5>
        </div>
        <div class="card-body">
          <div class="custom-control custom-radio mb-2">
            <%= f.radio_button :automatic, false, id: 'customRadio1', class: 'custom-control-input', checked: true, data: { action: 'reveal#hide' } %>
            <label class="custom-control-label" for="customRadio1"><%= Spree.t('admin.taxon_types.manual') %></label>
            <br />
            <span class="text-muted"><%= Spree.t('admin.taxon_types.manual_info') %></span>
          </div>
          <div class="custom-control custom-radio">
            <%= f.radio_button :automatic, true, id: 'customRadio2', class: 'custom-control-input', data: { action: 'reveal#show' } %>
            <label class="custom-control-label" for="customRadio2"><%= Spree.t('admin.taxon_types.automatic') %></label>
            <br />
            <span class="text-muted"><%= Spree.t('admin.taxon_types.automatic_info') %></span>
          </div>
        </div>
        <div class="card-body border-top pt-4 d-none" data-reveal-target="item">
          <h6><%= Spree.t(:conditions) %></h6>
          <%= render 'spree/admin/taxons/rules_form', f: f %>
        </div>
      </div>
    <% else %>
      <% if @taxon.automatic? %>
        <div class="card mb-4">
          <div class="card-header">
            <h5 class="card-title"><%= Spree.t(:conditions) %></h5>
          </div>
          <div class="card-body">
            <div class="alert alert-info mb-3"><%= Spree.t('admin.taxon_types.automatic_info') %></div>
            <%= render 'spree/admin/taxons/rules_form', f: f %>
          </div>
        </div>
      <% end %>

      <div class="card mb-4">
        <div class="card-header d-flex align-items-center justify-content-between">
          <h5 class="card-title">
            <%= Spree.t(:products) %>
            <span class="badge badge-info ml-2" id="product_count">
              <%= @taxon.products.not_archived.count %>
            </span>
          </h5>

          <% if @taxon.manual? %>
            <span data-toggle="modal" data-target="#modal">
              <%= link_to_with_icon 'plus', Spree.t(:add_products), spree.new_admin_taxon_classification_path(@taxon.id), class: 'btn btn-light btn-sm', data: { turbo_frame: 'dialog_modal' } %>
            </span>
          <% end %>
        </div>

        <div class="card-body border-bottom">
          <div class="d-flex align-items-center">
            <%= f.label :sort_order, class: 'text-nowrap mr-2 mb-0' %>
            <%= f.select :sort_order, taxon_sort_options_for_select, {}, { class: 'custom-select custom-select-sm w-auto',  data: { action: 'change->auto-submit#submit' } } %>
          </div>
        </div>

        <div class="card-body p-2" style="min-height: 300px">
          <div class="d-block overflow-y-auto overflow-x-hidden" style="max-height: 300px">
            <%= turbo_frame_tag :classifications, src: spree.admin_taxon_classifications_path(@taxon.id), loading: :lazy do %>
              <%= render 'spree/admin/shared/spinner' %>
            <% end %>
          </div>
        </div>
      </div>
    <% end %>
  </div>

  <div class="col-lg-4">
    <div class="card mb-4">
      <div class="card-header">
        <h5 class="card-title"><%= Spree.t(:images) %></h5>
      </div>
      <div class="card-body">
        <%= f.label :image, Spree.t(:image) %>
        <%= render 'active_storage/upload_form', form: f, field_name: :image, width: 1920, height: 1080 %>
        <%= f.error_message_on :image %>
      </div>

      <div class="card-body">
        <%= f.label :square_image, Spree.t(:square_image) %>
        <p class="text-muted form-text">
          Used for the featured image on the homepage.
        </p>
        <%= render 'active_storage/upload_form', form: f, field_name: :square_image, width: 400, height: 400, crop: true %>
        <%= f.error_message_on :square_image %>
      </div>
    </div>

    <div class="card mb-4">
      <div class="card-header">
        <h5 class="card-title">
          <%= Spree.t(:navigation) %>
        </h5>
      </div>
      <div class="card-body">
        <% if @taxon.new_record? %>
          <% disabled = false %>
        <% else %>
          <% disabled = @taxon.root? %>
        <% end %>
        <div class="form-group">
          <%= f.label :parent_id, Spree.t('admin.navigation.nested_under') %>
          <%= f.select :parent_id, nested_set_options(@taxonomy.taxons.includes(:parent), @taxon) {|i| i.pretty_name }, { include_blank: false }, { data: { controller: 'autocomplete-select' }, disabled: disabled  } %>
          <%= f.error_message_on :parent_id %>
        </div>
      </div>
    </div>

    <%= render 'spree/admin/shared/seo',
          f: f,
          title: @taxon.name,
          meta_title: @taxon.meta_title,
          description: @taxon.description,
          slug_attribute_name: :permalink_part,
          slug: @permalink_part,
          slug_path: ['t', @parent_permalink.presence].compact.join('/'),
          placeholder: 'Add a title and description to see how this taxon might appear in a search engine listing' %>
  </div>
</div>

admin/app/views/spree/admin/taxons/_rule_form.html.erb
<div class="row nested-form-wrapper border-bottom mb-3 pr-2" data-controller="rule-form" data-new-record="<%= rf.object.new_record? %>">
  <% @taxon_rules.each do |taxon_rule| %>
    <template id="rule-form-template-<%= taxon_rule.to_s.demodulize %>" data-rule-form-target="template">
      <%= render "spree/admin/taxons/rule_forms/#{taxon_rule.to_s.demodulize.underscore}", rule_form: rf %>
    </template>
  <% end %>

  <div class="col-lg-4 mb-3">
    <%= rf.select :type, @rule_types, {}, { class: 'custom-select', data: { action: 'rule-form#replace' } } %>
  </div>
  <div class="col-lg-3 mb-3">
    <%= rf.select :match_policy, @rule_match_policies, {}, { class: 'custom-select' } %>
  </div>
  <div class="col-lg-4 mb-3" data-rule-form-target="value">
    <%= render "spree/admin/taxons/rule_forms/#{rf.object.type.demodulize.underscore}", rule_form: rf %>
  </div>
  <div class="col-lg-1 mb-3 d-flex align-items-center justify-content-center">
    <button type="button" data-action="nested-form#remove" class="btn btn-sm btn-danger px-2 with-tip" title="Remove condition">
      <%= icon('x', class: 'mr-0') %>
      <span class="d-lg-none"><%= Spree.t(:remove_condition) %></span>
    </button>
    <%= rf.hidden_field :_destroy if rf.object.persisted? %>
  </div>
</div>

admin/app/views/spree/admin/taxons/_rules_form.html.erb
<div id="rules-form">
  <div class="form-group mb-1">
    <span class="d-block d-lg-inline mb-3"><%= Spree.t('admin.taxon_rules.products_must_match') %></span>

    <div class="custom-control custom-radio custom-control-inline ml-lg-3 mb-3">
      <%= f.radio_button :rules_match_policy, :all, class: 'custom-control-input' %>
      <%= f.label :rules_match_policy, Spree.t('admin.taxon_rules.all_conditions'), class: 'custom-control-label', for: :taxon_rules_match_policy_all %>
    </div>
    <div class="custom-control custom-radio custom-control-inline mb-3">
      <%= f.radio_button :rules_match_policy, :any, class: 'custom-control-input' %>
      <%= f.label :rules_match_policy, Spree.t('admin.taxon_rules.any_condition'), class: 'custom-control-label', for: :taxon_rules_match_policy_any %>
    </div>
  </div>

  <div data-controller="nested-form">
    <template data-nested-form-target="template">
      <%= f.fields_for :taxon_rules, @taxon.taxon_rules.new(type: @taxon_rules.first.to_s), child_index: 'NEW_RECORD' do |rf| %>
        <%= render 'spree/admin/taxons/rule_form', rf: rf %>
      <% end %>
    </template>

    <%= f.fields_for :taxon_rules, @taxon.taxon_rules do |rf| %>
      <%= render 'spree/admin/taxons/rule_form', rf: rf %>
    <% end %>

    <!-- Inserted elements will be injected before that target. -->
    <div data-nested-form-target="target" class="mb-2"></div>

    <button type="button" class="btn btn-link w-100 py-3" data-action="nested-form#add">
      <%= icon('plus', class: 'mr-2') %>
      <%= Spree.t(:add_one)%>
    </button>
  </div>
</div>

admin/app/views/spree/admin/taxons/destroy.turbo_stream.erb
<%= turbo_stream.remove spree_dom_id(@taxon) %>

admin/app/views/spree/admin/taxons/edit.html.erb
<% content_for :page_title do %>
  <%= page_header_back_button spree.admin_taxonomy_path(@taxon.taxonomy) %>
  <%= @taxon.name %>
<% end %>

<% content_for :page_actions_dropdown do %>
  <%= link_to_edit_translations(@taxon) %>
  <%= external_page_preview_link(@taxon, name: Spree.t(:taxonomy)) %>
<% end %>

<%# Because otherwise the form would attempt to use to_param of @taxon %>
<% form_url = admin_taxonomy_taxon_path(@taxonomy.id, @taxon.id) %>

<%= render partial: 'spree/admin/shared/error_messages', locals: { target: @taxon } %>

<%= form_for @taxon, as: :taxon, method: :put, url: form_url, html: { multipart: true }, data: { controller: 'auto-submit' } do |f| %>
  <%= render 'form', f: f %>
  <%= render 'spree/admin/shared/edit_resource_links', f: f %>
<% end %>

admin/app/views/spree/admin/taxons/new.html.erb
<% content_for :page_title do %>
  <%= page_header_back_button spree.admin_taxonomy_path(@taxonomy) %>
  <%= Spree.t(:new_taxon) %>
<% end %>

<%= render partial: 'spree/admin/shared/error_messages', locals: { target: @taxon } %>

<%= form_for @taxon, as: :taxon, url: spree.admin_taxonomy_taxons_path do |f| %>
  <%= render 'form', f: f %>

  <%= render 'spree/admin/shared/new_resource_links' %>
<% end %>